libname diabetes 'C:\Users\cancxs\Desktop\wiilsu, jun 2014\80-20 rule managing it with SAS\data';
*part 1b;
proc contents data=diabetes.pima out=test;
run;

*2. what are dictionary tables;
* 2.1 let's open up the SASHELP library to view the dictionary tables available;

*how to interact;
*2.2 ;
proc sql;
describe table dictionary.dictionaries;

*5 ways to use dictionary tables;

*2.3  find common columns to do your joins. 2.4 also answer efficiency question
proc sql or proc print;

proc sql;
describe table dictionary.columns;
select libname, memname, name, type, length
from dictionary.columns
where upcase(name) contains 'ID' and libname ='DIABETES';
quit;

* alternatively;

proc print data=sashelp.vcolumn;
var libname memname name type length;
where upcase(name) contains 'ID';
run;


/*2.5 - date column names have been changed and its hard to remember where */
/*all the date columns are now & what they are called;*/
proc sql;
select memname, name, type, length from sashelp.vcolumn
where libname='DIABETES' and upcase(name) like '%DATE%';
quit;

/*2.6 Put Variables Into Alpha Order*/

proc sql noprint;
select name into :newname separated by ","
from dictionary.columns
where libname ='DIABETES' and 
upcase(memname) ='PIMA'
order by name
;

create table ordered as
select &newname
from diabetes.Pima;

quit;

/*2.7 find all variable type conflicts globally;*/

proc sql ;
select libname, memname, name, type, length
from dictionary.columns
where upcase(name) contains 'ID' and libname='DIABETES'
group by name
having count(distinct type) > 1
order by 1, 2
;
quit;

*3.1 knowing if you have any duplicates;
proc freq data=diabetes.pima;
tables id;
run;

PROC FREQ   DATA=diabetes.pima noprint ;
   TABLES id /out=dupid(where=(count > 1));
run;
* knowing the largest value in your data;
proc means data=diabetes.pima max min mean;
run;

   proc univariate data=diabetes.pima nextrobs=10;
   run;
